<?php
	class postLike
	{
		private $post_likesnum;
		private $post_likes;
		private $network;
		private $user;
		private $post;
		private $db2;
		private $cache;
		private $comment_id;
		
		public function __construct( &$post, $comment_id = FALSE )
		{
			$this->post 	= $post;
			$this->db2 		= & $GLOBALS['db2'];
			$this->network 	= & $GLOBALS['network'];
			$this->cache 	= & $GLOBALS['cache'];
			$this->user 	= & $GLOBALS['user'];
			$this->post_likes		= array();
			$this->comment_id = $comment_id;
			
			$this->post_likes		= ( $post->post_type=='public' )? $this->get_post_likes() : array();
			$this->post_likesnum 	= ( $this->post_likes && isset($this->post_likes['post']))? count( $this->post_likes['post'] ) : 0;
		}
		
		public function could_be_liked()
		{
			if($this->post->error){
				return FALSE;
			}
			if($this->post->is_system_post){
				return FALSE;
			}
			if(!$this->user->is_logged){
				return FALSE;
			}
			if($this->post->post_type == 'private'){
				return FALSE;
			}
			if(!isset($this->post->post_user) || !$this->post->post_user){
				return FALSE;
			}
			if($this->user->id == $this->post->post_user->id){
				//return FALSE;
			}
			if( $this->is_post_liked() ){
				return FALSE;
			}
			return TRUE;
		}
		public function is_post_liked()
		{
			if( !isset($this->post_likes['post'][$this->user->id]) ){
				return FALSE;
			}
				
			return TRUE;
		}
		
		public function get_post_likes($force_refresh=FALSE)
		{
			if( $this->post->error ) {
				return FALSE;
			}
			if( $this->post->is_system_post ) {
				return FALSE;
			}
				
			$cachekey	= 'n:'.$this->network->id.',post_likes:'.$this->post->post_type.':'.$this->post->post_id;
			$data	= $this->cache->get($cachekey);
			if( FALSE!==$data && TRUE!=$force_refresh ) {
				return $data;
			}
			$data	= array('post'=>array());
			$r	= $this->db2->query('SELECT u.id, u.avatar, u.username, pl.post_id, pl.comment_id FROM users u, post_likes pl WHERE pl.user_id=u.id AND post_id="'.$this->post->post_id.'"', FALSE);
			while($o = $this->db2->fetch_object($r)) {
				if( $o->comment_id == 0 ){
					$data['post'][$o->id] = array($o->username, (!empty($o->avatar)? $o->avatar : $GLOBALS['C']->DEF_AVATAR_USER));
				}elseif( $o->comment_id > 0 ){
					$data['comment_'.$o->comment_id][$o->id] = array($o->username, (!empty($o->avatar)? $o->avatar : $GLOBALS['C']->DEF_AVATAR_USER));
				}
		
			}
			$this->cache->set($cachekey, $data, $GLOBALS['C']->CACHE_EXPIRE);
			return $data;
		}
		
		public function like_post($state=TRUE)
		{
			if( $this->post->error ) {
				return FALSE;
			}
			if( $this->post->is_system_post ) {
				return FALSE;
			}
			if( ! $this->user->is_logged ) {
				return FALSE;
			}
			$b	= $this->is_post_liked();
			$u	= intval($this->user->id);
			if( $b && !$state ) {
				$this->db2->query('DELETE FROM post_likes WHERE user_id="'.$u.'" AND post_id="'.$this->post->post_id.'" AND comment_id=0 LIMIT 1', FALSE);
				//$this->db2->query('UPDATE posts SET likes=likes-1 WHERE id="'.$this->post->post_id.'" LIMIT 1', FALSE);
			}
			elseif( !$b && $state ) {
				$this->db2->query('INSERT INTO post_likes SET user_id="'.$u.'", post_id="'.$this->post->post_id.'", date="'.time().'" ', FALSE);
				//$this->db2->query('UPDATE posts SET likes=likes+1 WHERE id="'.$this->post->post_id.'" LIMIT 1', FALSE);
			}
				
			$this->post_likes = array();
			$this->post_likes = $this->get_post_likes(TRUE);
			return TRUE;
		}
		
	}